<?php

if ($call == 'fetch_all')
{
    $customers = $db->query('SELECT * FROM customers ORDER BY id DESC')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($customers as $key => $customer)
    {
        $customers[$key]['orders_total_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE customer_id = '.$customer['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
        $customers[$key]['orders_completed_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE status = "completed" AND customer_id = '.$customer['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
        $customers[$key]['orders_uncompleted_count'] = $customers[$key]['orders_total_count'] - $customers[$key]['orders_completed_count'];
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Müşteriler başarıyla getirildi',
        'data' => $customers,
    ]);
}

if ($call == 'fetch')
{
    $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    $customer['orders_total_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE customer_id = '.$_GET['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
    $customer['orders_completed_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE status = "completed" AND customer_id = '.$_GET['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
    $customer['orders_uncompleted_count'] = $customer['orders_total_count'] - $customer['orders_completed_count'];

    echo json_encode([
        'status' => 'success',
        'message' => 'Müşteri başarıyla getirildi',
        'data' => $customer,
    ]);
}

if ($call == 'store')
{
    $customer = $db->prepare('INSERT INTO customers (user_id, name, email, phone, address, created_at, updated_at) VALUES (:user_id, :name, :email, :phone, :address, :created_at, :updated_at)');

    $customer->execute([
        'user_id' => $_POST['user_id'],
        'name' => $_POST['name'],
        'email' => $_POST['email'],
        'phone' => $_POST['phone'],
        'address' => $_POST['address'],
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s'),
    ]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Müşteri başarıyla eklendi',
        'data' => $db->query('SELECT * FROM customers WHERE id = ' . $db->lastInsertId())->fetch(PDO::FETCH_ASSOC),
    ]);
}

if ($call == 'update')
{
    $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_POST['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$customer) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Müşteri bulunamadı',
        ]);

        return;
    }

    $update = $db->prepare('UPDATE customers SET name = :name, email = :email, phone = :phone, address = :address, updated_at = :updated_at WHERE id = :id');

    $update->execute([
        'id' => $_POST['id'],
        'name' => $_POST['name'],
        'email' => $_POST['email'],
        'phone' => $_POST['phone'],
        'address' => $_POST['address'],
        'updated_at' => date('Y-m-d H:i:s'),
    ]);

    $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_POST['id'])->fetch(PDO::FETCH_ASSOC);

    $customer['orders_total_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE customer_id = '.$_POST['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
    $customer['orders_completed_count'] = $db->query('SELECT COUNT(id) as total FROM orders WHERE status = "completed" AND customer_id = '.$_POST['id'])->fetch(PDO::FETCH_ASSOC)['total'] ?? 0;
    $customer['orders_uncompleted_count'] = $customer['orders_total_count'] - $customer['orders_completed_count'];

    echo json_encode([
        'status' => 'success',
        'message' => 'Müşteri başarıyla güncellendi',
        'data' => $customer,
    ]);
}

if ($call == 'destroy')
{
    $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$customer) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Müşteri bulunamadı',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM customers WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Müşteri başarıyla silindi',
    ]);
}

// Relation with Products

if ($call == 'fetch_all_products')
{
    $products = $db->query('SELECT t1.*, COALESCE(CAST(SUM(t2.quantity) AS UNSIGNED), 0) as stock_quantity FROM products t1 LEFT JOIN product_stocks t2 ON t2.product_id = t1.id WHERE t1.user_id = '. $_GET['user_id'] .'  GROUP BY t1.id ORDER BY t1.id DESC')->fetchAll(PDO::FETCH_ASSOC);

    $orderedProductExist = false;

    foreach ($products as $key => $product)
    {
        $lastOrder = $db->query('SELECT quantity, unit_price, total_price FROM order_products WHERE product_id = '.$product['id'].' AND customer_id = '. $_GET['customer_id'] .' ORDER BY created_at DESC')->fetch(PDO::FETCH_ASSOC);

        if ($lastOrder != null)
        {
            $products[$key]['is_ordered'] = true;
            $products[$key]['last_order'] = $lastOrder;
            $products[$key]['sale_price'] = $lastOrder['unit_price'];

            if ($orderedProductExist == false)
            {
                $orderedProductExist = true;
            }
        }
        else {
            $products[$key]['is_ordered'] = false;
            $products[$key]['sale_price'] = $products[$key]['unit_price'];
        }
    }

    // reorder products by is_ordered
    if ($orderedProductExist)
    {
        $orderedProducts = [];
        $notOrderedProducts = [];

        foreach ($products as $key => $product)
        {
            if ($product['is_ordered'])
            {
                $orderedProducts[] = $product;
            }
            else {
                $notOrderedProducts[] = $product;
            }
        }

        $products = array_merge($orderedProducts, $notOrderedProducts);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürünler başarıyla getirildi',
        'data' => $products,
    ]);
}