<?php

if ($call == 'fetch_all')
{
    $orders = $db->query('SELECT * FROM orders WHERE user_id = '. $_GET['user_id'] .' ORDER BY id DESC')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($orders as $key => $order)
    {
        $orders[$key]['products'] = $db->query('SELECT t1.*, COALESCE(CAST(SUM(t2.quantity) AS UNSIGNED), 0) as stock_quantity FROM products t1 LEFT JOIN product_stocks t2 ON t2.product_id = t1.id WHERE t1.id IN ('.$order['products'].') GROUP BY t1.id')->fetchAll(PDO::FETCH_ASSOC);
        $orders[$key]['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$order['customer_id'])->fetch(PDO::FETCH_ASSOC);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Siparişler başarıyla getirildi',
        'data' => $orders,
    ]);
}

if ($call == 'fetch_all_unfinished')
{
    $orders = $db->query('SELECT * FROM orders WHERE user_id = '. $_GET['user_id'] .' AND status != "completed" AND status != "transferred" ORDER BY id DESC')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($orders as $key => $order)
    {
        $orders[$key]['products'] = $db->query('SELECT t1.*, COALESCE(CAST(SUM(t2.quantity) AS UNSIGNED), 0) as stock_quantity FROM products t1 LEFT JOIN product_stocks t2 ON t2.product_id = t1.id WHERE t1.id IN ('.$order['products'].') GROUP BY t1.id')->fetchAll(PDO::FETCH_ASSOC);
        $orders[$key]['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$order['customer_id'])->fetch(PDO::FETCH_ASSOC);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Siparişler başarıyla getirildi',
        'data' => $orders,
    ]);
}

if ($call == 'fetch_statuses')
{
    $statuses = $db->query('SELECT * FROM order_statuses')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sipariş durumları başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch_currencies')
{
    $statuses = $db->query('SELECT * FROM currencies')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Para birimleri başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch')
{
    $order = $db->query('SELECT * FROM orders WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    $order['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$order['customer_id'])->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sipariş başarıyla getirildi',
        'data' => $order,
    ]);
}

if ($call == 'store')
{
    $products = json_decode($_POST['products'], true);

    $productIds = [];

    $taxRate = $_POST['tax_rate'];
    $discountAmount = $_POST['discount_amount'];
    
    $totalPrice = 0;
    $generalTotalPrice = 0;
    $taxAmount = 0;

    foreach ($products as $product)
    {
        $totalPrice += $product['total_price'];
        $productIds[] = $product['id'];
    }

    $taxAmount = moneyFormat($totalPrice * $taxRate / 100);
    $generalTotalPrice = moneyFormat($totalPrice + $taxAmount - $discountAmount);
    $discountRate = $discountAmount != 0 ? moneyFormat($discountAmount * 100 / $totalPrice) : 0;

    $data = [
        'user_id' => $_POST['user_id'],
        'company_id' => $_POST['company_id'],
        'customer_id' => $_POST['customer_id'],
        'order_id' => '',
        'name' => $_POST['name'],
        'products' => implode(',', $productIds),
        'order_date' => $_POST['order_date'] == '' ? date('Y-m-d') : $_POST['order_date'],
        'currency_id' => $db->query('SELECT * FROM currencies WHERE is_default = 1')->fetch(PDO::FETCH_ASSOC)['id'],
        'total_price' => $totalPrice,
        'discount_amount' => $discountAmount,
        'discount_rate' => $discountRate,
        'tax_amount' => $taxAmount,
        'tax_rate' => $taxRate,
        'general_total_price' => $generalTotalPrice,
        'advance' => 0,
        'balance' => $generalTotalPrice,
        'total_collection' => $generalTotalPrice,
        'remaining_collection' => $generalTotalPrice,
        'notes' => $_POST['notes'],
        'status' => 'new',
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s'),
    ];

    $create = $db->prepare('INSERT INTO orders SET ' . getQueryParameters($data));
    
    if (!$create->execute($data))
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Sipariş kaydedilirken bir hata oluştu',
        ]);

        return;
    }

    $createdOrderId = $db->lastInsertId();

    $productIds = '';

    foreach ($products as $product)
    {
        $orderProductData = [
            'user_id' => $_POST['user_id'],
            'company_id' => $_POST['company_id'],
            'customer_id' => $_POST['customer_id'],
            'order_id' => $db->lastInsertId(),
            'product_id' => $product['id'],
            'quantity' => $product['quantity'],
            'unit_price' => $product['unit_price'],
            'total_price' => $product['total_price'],
        ];

        $productIds .= $product['id'] . ',';

        $createOrderProduct = $db->prepare('INSERT INTO order_products SET ' . getQueryParameters($orderProductData));
        $createOrderProduct->execute($orderProductData);
    }

    $productIds = rtrim($productIds, ',');

    $order = $db->query('SELECT * FROM orders WHERE id = ' . $createdOrderId)->fetch(PDO::FETCH_ASSOC);
    
    $order['products'] = $db->query('SELECT * FROM products WHERE id IN ('.$productIds.')')->fetchAll(PDO::FETCH_ASSOC);
    $order['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$order['customer_id'])->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sipariş başarıyla kaydedildi',
        'data' => $order,
    ]);
}

if ($call == 'fetch_products')
{    
    $orderProducts = $db->query('SELECT t1.* FROM products t1 WHERE t1.id IN (SELECT CONCAT(product_id) FROM order_products t2 WHERE t2.order_id = '. $_GET['order_id'].')')->fetchAll(PDO::FETCH_ASSOC);

    if ($orderProducts != null && count($orderProducts) > 0)
    {
        foreach ($orderProducts as $key => $orderProduct)
        {
            $orderProducts[$key]['order_details'] = $db->query('SELECT * FROM order_products WHERE order_id = '.$_GET['order_id'].' AND product_id = '.$orderProduct['id'])->fetch(PDO::FETCH_ASSOC);
            $orderProducts[$key]['sale_price'] = $orderProducts[$key]['order_details']['unit_price'];
        }
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Sipariş ürünleri başarıyla getirildi',
        'data' => $orderProducts,
    ]);
}

// if ($call == 'destroy')
// {
//     $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

//     if (!$customer) {
//         echo json_encode([
//             'status' => 'error',
//             'message' => 'Müşteri bulunamadı',
//         ]);

//         return;
//     }

//     $delete = $db->prepare('DELETE FROM customers WHERE id = :id');
//     $delete->execute(['id' => $_GET['id']]);

//     echo json_encode([
//         'status' => 'success',
//         'message' => 'Müşteri başarıyla silindi',
//     ]);
// }