<?php

if ($call == 'fetch_all')
{
    $shipments = $db->query('SELECT * FROM shipments WHERE user_id = '. $_GET['user_id'] .' ORDER BY id DESC')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($shipments as $key => $shipment)
    {
        $shipments[$key]['order'] = $db->query('SELECT t1.*, COALESCE(CAST(SUM(t2.quantity) AS UNSIGNED), 0) as stock_quantity FROM products t1 LEFT JOIN product_stocks t2 ON t2.product_id = t1.id WHERE t1.id IN ('.$shipment['products'].') GROUP BY t1.id')->fetchAll(PDO::FETCH_ASSOC);
        $shipments[$key]['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$shipment['customer_id'])->fetch(PDO::FETCH_ASSOC);
        $shipments[$key]['products'] = $db->query('SELECT * FROM products WHERE id IN ('.$shipment['products'].')')->fetchAll(PDO::FETCH_ASSOC);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Sevkiyatlar başarıyla getirildi',
        'data' => $shipments,
    ]);
}

if ($call == 'fetch_statuses')
{
    $statuses = $db->query('SELECT * FROM shipment_statuses')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sevkiyat durumları başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch_currencies')
{
    $statuses = $db->query('SELECT * FROM currencies')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Para birimleri başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch')
{
    $shipment = $db->query('SELECT * FROM shipments WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    $shipment['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$shipment['customer_id'])->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sevkiyat başarıyla getirildi',
        'data' => $shipment,
    ]);
}

if ($call == 'store')
{
    $products = json_decode($_POST['products'], true);

    $productIds = [];

    $taxRate = 20;//$_POST['tax_rate'];
    $discountAmount = 0;//$_POST['discount_amount'];
    
    $totalPrice = 0;
    $generalTotalPrice = 0;
    $taxAmount = 0;

    $productsFromStock = [];
    $productsNotEnoughStock = [];

    foreach ($products as $product)
    {
        $totalPrice += $product['total_price'];
        $productIds[] = $product['id'];

        // Önce stoktan düşüreceğimiz ürünleri kontrol edelim

        $checkStock = $db->query('SELECT quantity FROM product_stocks WHERE warehouse_id = '.$_POST['warehouse_id'].' AND product_id = '.$product['id'])->fetch(PDO::FETCH_ASSOC);

        if (!$checkStock || $checkStock['quantity'] < $product['quantity'])
        {
            $productsNotEnoughStock[] = [
                'product_id' => $product['id'],
                'quantity' => $product['quantity'],
            ];
        }
        else
        {
            $productsFromStock[] = [
                'warehouse_id' => $_POST['warehouse_id'],
                'product_id' => $product['id'],
                'quantity' => $checkStock['quantity'] - $product['quantity'],
            ];
        }

    }

    // Eğer stokta miktarı yeterli olmayan ürünler varsa hata döndürelim
    if (count($productsNotEnoughStock) > 0)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bir veya daha fazla ürün stokta yeterli miktarda bulunmuyor!',
            'data' => $productsNotEnoughStock,
            'error_code' => 'not_enough_stock',
        ]);

        return;
    }

    $taxAmount = moneyFormat($totalPrice * $taxRate / 100);
    $generalTotalPrice = moneyFormat($totalPrice + $taxAmount - $discountAmount);
    $discountRate = $discountAmount != 0 ? moneyFormat($discountAmount * 100 / $totalPrice) : 0;

    $data = [
        'user_id' => $_POST['user_id'],
        'company_id' => $_POST['company_id'],
        'customer_id' => $_POST['customer_id'],
        'shipment_id' => '',
        'order_id' => $_POST['order_id'],
        'name' => $_POST['name'],
        'products' => implode(',', $productIds),
        'shipment_date' => $_POST['shipment_date'] ?? date('Y-m-d'),
        'currency_id' => $db->query('SELECT * FROM currencies WHERE is_default = 1')->fetch(PDO::FETCH_ASSOC)['id'],
        'total_price' => $totalPrice,
        'discount_amount' => $discountAmount,
        'discount_rate' => $discountRate,
        'tax_amount' => $taxAmount,
        'tax_rate' => $taxRate,
        'general_total_price' => $generalTotalPrice,
        'advance' => 0,
        'balance' => $generalTotalPrice,
        'total_collection' => $generalTotalPrice,
        'remaining_collection' => $generalTotalPrice,
        'notes' => $_POST['notes'],
        'status' => 'new',
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s'),
    ];

    $create = $db->prepare('INSERT INTO shipments SET ' . getQueryParameters($data));
    
    if (!$create->execute($data))
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Sevkiyat kaydedilirken bir hata oluştu',
        ]);

        return;
    }

    $createdOrderId = $db->lastInsertId();

    $productIds = '';

    foreach ($products as $product)
    {
        $shipmentProductData = [
            'user_id' => $_POST['user_id'],
            'company_id' => $_POST['company_id'],
            'customer_id' => $_POST['customer_id'],
            'shipment_id' => $db->lastInsertId(),
            'product_id' => $product['id'],
            'quantity' => $product['quantity'],
            'unit_price' => $product['unit_price'],
            'total_price' => $product['total_price'],
            'original_quantity' => $product['original_quantity'],
            'original_total_price' => $product['original_total_price'],
        ];

        $productIds .= $product['id'] . ',';

        $createOrderProduct = $db->prepare('INSERT INTO shipment_products SET ' . getQueryParameters($shipmentProductData));
        $createOrderProduct->execute($shipmentProductData);
    }

    $productIds = rtrim($productIds, ',');

    $shipment = $db->query('SELECT * FROM shipments WHERE id = ' . $createdOrderId)->fetch(PDO::FETCH_ASSOC);
    
    $shipment['products'] = $db->query('SELECT * FROM products WHERE id IN ('.$productIds.')')->fetchAll(PDO::FETCH_ASSOC);
    $shipment['customer'] = $db->query('SELECT * FROM customers WHERE id = '.$shipment['customer_id'])->fetch(PDO::FETCH_ASSOC);

    // Ürünleri stoktan düşelim

    foreach ($productsFromStock as $product)
    {
        $updateStock = $db->prepare('UPDATE product_stocks SET quantity = :quantity WHERE warehouse_id = :warehouse_id AND product_id = :product_id');
        $updateStock->execute($product);
    }

    // Siparişi güncelleyelim

    $updateOrder = $db->prepare('UPDATE orders SET status = :status, delivery_date = :delivery_date WHERE id = :id');
    $updateOrder->execute([
        'status' => 'transferred',
        'delivery_date' => date('Y-m-d H:i:s'),
        'id' => $_POST['order_id'],
    ]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Sevkiyat başarıyla kaydedildi',
        'data' => $shipment,
    ]);
}

// if ($call == 'destroy')
// {
//     $customer = $db->query('SELECT * FROM customers WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

//     if (!$customer) {
//         echo json_encode([
//             'status' => 'error',
//             'message' => 'Müşteri bulunamadı',
//         ]);

//         return;
//     }

//     $delete = $db->prepare('DELETE FROM customers WHERE id = :id');
//     $delete->execute(['id' => $_GET['id']]);

//     echo json_encode([
//         'status' => 'success',
//         'message' => 'Müşteri başarıyla silindi',
//     ]);
// }