<?php

if ($call == 'fetch_all')
{
    $sth = $db->prepare('SELECT t1.* FROM warehouse_areas t1 WHERE t1.company_id = :company_id');
    
    $sth->execute([
        ':company_id' => $_GET['company_id'],
    ]);
    
    $data = $sth->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Bölgeler başarıyla getirildi.',
        'data' => $data
    ]);
}

if ($call == 'fetch')
{
    $sth = $db->prepare('SELECT t1.* FROM warehouse_areas t1 WHERE t1.id != :id');
    $sth->execute([
        ':id' => $_GET['id'],
    ]);

    $data = $sth->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Bölge başarıyla getirildi.',
        'data' => $data
    ]);
}

if ($call == 'store')
{
    $data = [
        'company_id' => $_POST['company_id'],
        'name' => $_POST['name'],
        'created_by' => $_POST['user_id'],
    ];

    $sth = $db->prepare('SELECT id FROM warehouse_areas WHERE name = ? AND company_id = ? LIMIT 1');
    $sth->execute([$_POST['name'], $_POST['company_id']]);
    $checkName = $sth->fetch(PDO::FETCH_ASSOC);

    if ($checkName)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu bölge adı kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO warehouse_areas SET ' . getQueryParameters($data));
    $sth->execute($data);

    $id = $db->lastInsertId();

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM warehouse_areas WHERE id = ' . $id)->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'update')
{
    $data = [
        'id' => $_POST['id'],
        'name' => $_POST['name'],
    ];

    $sth = $db->prepare('SELECT id FROM warehouse_areas WHERE name = ? AND id != ? AND company_id = ? LIMIT 1');
    $sth->execute([$_POST['name'], $_POST['id'], $_POST['company_id']]);
    $checkName = $sth->fetch(PDO::FETCH_ASSOC);

    if ($checkName)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu bölge adı kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('UPDATE warehouse_areas SET ' . getQueryParameters($data, ['id']) . ' WHERE id = :id');
    $sth->execute($data);

    echo json_encode([
        'status' => 'success',
        'message' => 'Güncelleme başarılı.',
        'data' => $db->query('SELECT * FROM warehouse_areas WHERE id = ' . $data['id'])->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'destroy')
{
    $checkExists = $db->query('SELECT * FROM warehouse_areas WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$checkExists) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bölge bulunamadı.',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM warehouse_areas WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Bölge başarıyla silindi',
    ]);
}